#ifdef HAVE_CONFIG_H
#	include "config.h"
#endif

#include <stdio.h>
#include <errno.h>

#include "misc.h"
#include "lbx.h"

int _lbx_fseek(FILE *f, long *current, size_t offset)
{
	static unsigned char oblivion[1024];
	long dist;

	if (*current < offset) {
		dist = offset - *current;
	} else if (*current > offset) {
		dist = -(long)(*current - offset);
	} else {
		return 0;
	}

	if (fseek(f, dist, SEEK_CUR) == 0) {
		*current += dist;
	} else if (*current < offset) {
		while (dist) {
			size_t rc, amt = MIN(sizeof oblivion, dist);
			rc = fread(oblivion, 1, amt, f);
			*current += rc;
			dist -= rc;
			if (rc < amt) {
				if (feof(f))
					lbx_errno = LBX_EEOF;
				else
					lbx_errno = -errno;
				return -1;
			}
		}
	} else {
		lbx_errno = -errno;
		return -1;
	}
	return 0;
}
